/**
 * Injects `ApiClient` instance imported from `@twurple/api`.
 *
 * @example
 * import { ApiClient } from '@twurple/api';
 *
 * ```ts
 * @Injectable()
 * export class CustomProvider {
 *     constructor(@InjectApiClient() private readonly _apiClient: ApiClient) {}
 * }
 * ```
 */
export declare const InjectApiClient: () => ParameterDecorator;
//# sourceMappingURL=inject-api-client.decorator.d.ts.map