"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InjectApiClient = void 0;
const common_1 = require("@nestjs/common");
const constants_1 = require("../constants");
/**
 * Injects `ApiClient` instance imported from `@twurple/api`.
 *
 * @example
 * import { ApiClient } from '@twurple/api';
 *
 * ```ts
 * @Injectable()
 * export class CustomProvider {
 *     constructor(@InjectApiClient() private readonly _apiClient: ApiClient) {}
 * }
 * ```
 */
const InjectApiClient = () => (0, common_1.Inject)(constants_1.TWURPLE_API_CLIENT);
exports.InjectApiClient = InjectApiClient;
