import { type DynamicModule } from '@nestjs/common';
import { type TwurpleApiModuleAsyncOptions, type TwurpleApiModuleOptions } from './interfaces/twurple-api-module-options.interface';
/**
 * Twurple API client module.
 *
 * The module must be registered using either `register` or `registerAsync` static methods.
 */
export declare class TwurpleApiModule {
    /**
     * Registers the module synchronously by direct options passing.
     *
     * @param options Twurple API module options.
     */
    static register(options: TwurpleApiModuleOptions): DynamicModule;
    /**
     * Registers the module asynchronously using one of the following factories: "useFactory", "useExisting", or
     * "useClass".
     *
     * @param options Twurple API module async options.
     */
    static registerAsync(options: TwurpleApiModuleAsyncOptions): DynamicModule;
    private static _createOptionsProvider;
    private static _createAsyncOptionsProviders;
    private static _createAsyncOptionsProvider;
    private static _createApiClientProvider;
}
//# sourceMappingURL=twurple-api.module.d.ts.map